<template>
  <b-overlay :show="loggingIn" class="h-100" variant="dark">
    <div class="text-center">
      <h2
        v-html="$marked($t('returning.login.title'))"
        class="text-uppercase"
      ></h2>

      <div class="font-large text-white">
        <b-form @submit.prevent="tryLogin" class="text-center">
          <b-form-group
            :label="$t('login.username')"
            label-class="d-none d-xl-block"
          >
            <b-form-input
              v-model="form.character"
              :placeholder="$t('login.username')"
              trim
              class="d-inline-block hide-placeholder-xl"
              style="max-width: 225px;"
              autocomplete="username"
            ></b-form-input>
          </b-form-group>

          <b-form-group
            :label="$t('login.password')"
            label-class="d-none d-xl-block"
          >
            <b-form-input
              v-model="form.password"
              :placeholder="$t('login.password')"
              type="password"
              trim
              class="d-inline-block hide-placeholder-xl"
              style="max-width: 225px;"
              autocomplete="current-password"
            ></b-form-input>
          </b-form-group>

          <b-alert :show="!!error" variant="danger">{{ $t(error) }}</b-alert>

          <b-button
            :disabled="!validForm"
            type="submit"
            class="text-uppercase"
            >{{ $t('button.login') }}</b-button
          >
        </b-form>
      </div>
    </div>
  </b-overlay>
</template>

<script>
export default {
  data() {
    return {
      form: {
        character: '',
        password: '',
      },
      error: null,
      loggingIn: false,
    };
  },
  computed: {
    validForm() {
      return this.form.character.length > 0 && this.form.password.length > 0;
    },
  },
  methods: {
    onClick() {
      this.$emit('clicked');
    },
    async tryLogin() {
      this.error = null;

      this.loggingIn = true;

      this.error = await this.$store.dispatch('ryauth/login', {
        username: this.form.character,
        password: this.form.password,
      });

      this.loggingIn = false;
    },
  },
};
</script>
